diff --git a/app/fin/task/billing_shared_electric_task.go b/app/fin/task/billing_shared_electric_task.go
index f19c7db3fb9664fca2dd43a9f71f2dbcf13f99c5..864fc1cbf07bfc249abe31f178ab0f88a14465ec 100644
--- a/app/fin/task/billing_shared_electric_task.go
+++ b/app/fin/task/billing_shared_electric_task.go
@@ -1,8 +1,8 @@
 package task
 
 import (
+	"encoding/json"
 	"strconv"
-	"strings"
 	"time"
 
 	devSvr "energy-server-mgo/app/admin/service/device"
@@ -11,6 +11,8 @@ import (
 	finReq "energy-server-mgo/app/fin/schemas"
 	finSvr "energy-server-mgo/app/fin/service"
 	"energy-server-mgo/core"
+	"energy-server-mgo/core/response"
+	"energy-server-mgo/util"
 )
 
 /**
@@ -26,6 +28,7 @@ type SharedElectricTask struct {
 	srvPayment         finSvr.IFinPaymentService
 	srvRecord          finSvr.IFinDeviceRecordService
 	srvScheme          finSvr.IFinApportionSchemesService
+	srvPurse           finSvr.IFinPurseService
 	srvSharedCommon    *SharedCommon
 }
 
@@ -77,144 +80,112 @@ func newSharedElectricTask() *SharedElectricTask {
 	}); err != nil {
 		panic(err)
 	}
+	if err := core.GetContainer().Invoke(func(s finSvr.IFinPurseService) {
+		server.srvPurse = s
+	}); err != nil {
+		panic(err)
+	}
 	server.srvSharedCommon = NewSharedCommon()
 
 	return server
 }
 
 // 计算电力公摊费用
-func (task *SharedElectricTask) calcFee() {
-	core.TryLock(constants.Lock_key_SElectric, "1", 5*time.Minute)
-	defer core.UnLock(constants.Lock_key_SElectric)
-
+func (task *SharedElectricTask) calcFee(houseId uint, deviceId uint, startDay, endDay time.Time) {
 	now := time.Now()
-	// 将时间截断到当天的零点
-	endDay := time.Date(now.Year(), now.Month(), now.Day(), 0, 0, 0, 0, now.Location())
-	startDay := endDay.AddDate(0, 0, -1)
+	deviceTypes := []string{"em"}
 
 	var cond finReq.FinSharedListReq
+	cond.CommonAreaId = houseId
 	lists, _ := task.srvElectric.ListAll(cond)
 	for _, scheme := range lists {
 		if len(scheme.AreaIds) <= 0 {
 			continue
 		}
-		var areaIds []uint
-		for _, val := range strings.Split(scheme.AreaIds, ",") {
-			tmpId, err := strconv.ParseUint(val, 10, 64)
-			if err != nil {
-				continue
+		needBill := "1"
+		if len(scheme.MigrDate) > 0 {
+			date, err := strconv.Atoi(scheme.MigrDate)
+			if err != nil && date < time.Now().Day() {
+				needBill = "0"
 			}
-			areaIds = append(areaIds, uint(tmpId))
-		}
-		deviceIds, _ := task.srvCommon.ListAreaDeviceIds(areaIds, []string{"em"})
-
-		deviceList, _ := task.srvApportionDevice.ListAllBindDevice(scheme.Id, "electric", nil, deviceIds)
-		billingMethod := scheme.BillingMethod
-		var schemeTimes []*SchemeTime
-		switch billingMethod {
-		case "1", "2":
-			schemeTimes = getDateStd(0, billingMethod, startDay, endDay, scheme.Price)
-			break
-		case "3":
-			schemeTimes = getYearDateStd(0, billingMethod, startDay, endDay, scheme.Price)
-			break
-		case "4", "5":
-			schemeTimes = getStepDateStd(0, billingMethod, startDay, endDay, scheme.Price)
-			break
 		}
-		if schemeTimes == nil {
+		deviceRecords, err := task.srvRecord.ListByHouseId(0, 0, deviceId, "", true, startDay, endDay)
+		if err == nil {
 			continue
 		}
-
 		usageTotal := float64(0.00)
 		billAmount := float64(0.00)
-		var deviceRecords []finModel.FinDeviceRecord
-		for i := 0; i < len(deviceList); i++ {
-			device := deviceList[i]
-			num, err := task.srvRecord.GetRecordNum(device.HouseId, device.DeviceId, constants.BillTypeEnum.SElectric, startDay, endDay)
+
+		var saveRecords []finModel.FinDeviceRecord
+		for _, record := range deviceRecords {
+			num, err := task.srvRecord.GetRecordNum(0, record.DeviceId, constants.BillTypeEnum.SElectric, startDay, endDay)
 			if err != nil || num > 0 {
 				continue
 			}
-			totalUsageStart := 0.00
-			totalUsageEnd := 0.00
-			for _, schemeTime := range schemeTimes {
-				startValue, err := task.srvInstrument.QueryDeviceFirstValue(device.DeviceId, schemeTime.startDay.Unix())
-				if err != nil {
-					startValue = 0.00
-				}
-				endValue, err := task.srvInstrument.QueryDeviceFirstValue(device.DeviceId, schemeTime.endDay.Unix())
-				if err != nil {
-					endValue, _, _ = task.srvInstrument.QueryNewDeviceValue(device.DeviceId, schemeTime.startDay.Unix(), schemeTime.endDay.Unix())
-				}
-				if endValue == 0.00 {
-					endValue = startValue
-				}
-				totalUsageStart += startValue
-				totalUsageEnd += endValue
-				usageTotal += endValue - startValue
-				schemeTime.usageTotal = endValue - startValue
-				schemeTime.regionId = device.RegionId
-				schemeTime.regionName = device.RegionName
-				schemeTime.areaId = device.AreaId
-				schemeTime.areaName = device.AreaName
-				schemeTime.houseId = device.HouseId
-				schemeTime.houseName = device.HouseName
-			}
 			if scheme.Llf != 0.00 {
 				usageTotal = usageTotal * (1.00 + scheme.Llf)
 			}
-			switch billingMethod {
-			case "1":
-				schemeTimes = calcUnitFee(schemeTimes)
-				break
-			case "2":
-				schemeTimes = calcMonthFee(schemeTimes)
-				break
-			case "3":
-				schemeTimes = calcYearFee(schemeTimes)
-				break
-			case "4", "5":
-				schemeTimes = calcStepFee(schemeTimes)
-				break
-			default:
-				break
-			}
-			for _, schemeTime := range schemeTimes {
-				billAmount += schemeTime.billAmmount
-			}
-			record := finModel.FinDeviceRecord{
-				SchemeId:   scheme.Id,
-				BillType:   constants.BillTypeEnum.SElectric,
-				RegionId:   scheme.RegionId,
-				RegionName: scheme.RegionName,
-				AreaId:     scheme.AreaId,
-				AreaName:   scheme.AreaName,
-				HouseId:    device.HouseId,
-				HouseName:  device.HouseName,
-				DeviceId:   device.DeviceId,
-				DeviceName: device.DeviceName,
-				FeeDate:    startDay,
-				BillAmount: billAmount,
-				UsageTotal: usageTotal,
-				UsageStart: totalUsageStart,
-				UsageEnd:   totalUsageEnd,
-			}
+			var item finModel.FinDeviceRecord
+			response.Copy(record, &item)
+			item.Id = 0
+			item.SchemeId = scheme.Id
+			item.BillType = constants.BillTypeEnum.SElectric
+			item.CommonAreaId = record.HouseId
+			item.CommonAreaName = record.HouseName
+			item.FeeDate = startDay
+			item.StepFee = record.StepFee
+			item.NeedBill = needBill
 			record.CreateTime = now
-			deviceRecords = append(deviceRecords, record)
+			saveRecords = append(saveRecords, item)
 		}
 		switch scheme.ApportionMethod {
 		case "0":
-			deviceRecords = task.srvSharedCommon.calcSharedSquareFee(deviceRecords, scheme.SquareType, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedSquareFee(saveRecords, deviceTypes, scheme.MigrDate, startDay, scheme.SquareType, billAmount)
 			break
 		case "1":
-			deviceRecords = task.srvSharedCommon.calcSharedHouseFee(deviceRecords, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedHouseFee(saveRecords, deviceTypes, scheme.MigrDate, startDay, billAmount)
 			break
 		case "2":
-			deviceRecords = task.srvSharedCommon.calcSharedSelfFee(deviceRecords, scheme.Price, startDay, endDay, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedSelfFee(saveRecords, deviceTypes, scheme.MigrDate, scheme.Price, startDay, endDay, billAmount)
 			break
 		}
-		if len(deviceRecords) > 0 {
-			task.srvRecord.SaveBatch(deviceRecords)
+		if len(saveRecords) > 0 {
+
+			purseRecordMap := make(map[uint]finReq.FinPurseFeeEditReq)
+			if len(saveRecords) > 0 {
+				err := task.srvRecord.SaveBatch(saveRecords)
+				if err != nil {
+					continue
+				}
+				for _, record := range saveRecords {
+					feeReq, find := purseRecordMap[record.HouseId]
+					if !find {
+						purse, err := task.srvPurse.DetailByHouseId(record.HouseId, nil)
+						if err != nil && purse.Id <= 0 {
+							continue
+						}
+						feeReq = finReq.FinPurseFeeEditReq{
+							HouseId:       record.HouseId,
+							EcsType:       "electric",
+							FeeType:       "deduct",
+							FlowType:      "purse",
+							Amount:        record.BillAmount,
+							PaymentTime:   now,
+							PaymentSource: "0",
+							PaymentMethod: "0",
+						}
+					}
+					feeReq.Amount += record.BillAmount
+					purseRecordMap[record.HouseId] = feeReq
+				}
+				for _, purseReq := range purseRecordMap {
+					jsStr, err := json.Marshal(purseReq)
+					if err != nil {
+						continue
+					}
+					util.RedisUtil.LPush(constants.Task_Purse_Que, jsStr)
+				}
+			}
 		}
 	}
 }
diff --git a/app/fin/task/billing_shared_gas_task.go b/app/fin/task/billing_shared_gas_task.go
index 11c6dca028ca6bc1be7679970d948808f17515f6..0ec9be4a640a14264c96038f2e871c23454cfa28 100644
--- a/app/fin/task/billing_shared_gas_task.go
+++ b/app/fin/task/billing_shared_gas_task.go
@@ -1,8 +1,8 @@
 package task
 
 import (
+	"encoding/json"
 	"strconv"
-	"strings"
 	"time"
 
 	devSvr "energy-server-mgo/app/admin/service/device"
@@ -11,6 +11,8 @@ import (
 	finReq "energy-server-mgo/app/fin/schemas"
 	finSvr "energy-server-mgo/app/fin/service"
 	"energy-server-mgo/core"
+	"energy-server-mgo/core/response"
+	"energy-server-mgo/util"
 )
 
 /**
@@ -27,6 +29,7 @@ type SharedGasTask struct {
 	srvRecord          finSvr.IFinDeviceRecordService
 	srvApportionRatio  finSvr.IFinApportionRatioService
 	srvScheme          finSvr.IFinApportionSchemesService
+	srvPurse           finSvr.IFinPurseService
 }
 
 // NewSharedGasTask 实例化
@@ -77,135 +80,108 @@ func newSharedGasTask() *SharedGasTask {
 	}); err != nil {
 		panic(err)
 	}
+	if err := core.GetContainer().Invoke(func(s finSvr.IFinPurseService) {
+		server.srvPurse = s
+	}); err != nil {
+		panic(err)
+	}
 	server.srvSharedCommon = NewSharedCommon()
 
 	return server
 }
 
 // 计算燃气公摊费用
-func (task *SharedGasTask) calcFee() {
-	core.TryLock(constants.Lock_key_SGas, "1", 5*time.Minute)
-	defer core.UnLock(constants.Lock_key_SGas)
-
+func (task *SharedGasTask) calcFee(houseId uint, deviceId uint, startDay, endDay time.Time) {
 	now := time.Now()
-	// 将时间截断到当天的零点
-	endDay := time.Date(now.Year(), now.Month(), now.Day(), 0, 0, 0, 0, now.Location())
-	startDay := endDay.AddDate(0, 0, -1)
+	deviceTypes := []string{"gas"}
 
 	var cond finReq.FinSharedListReq
+	cond.CommonAreaId = houseId
 	lists, _ := task.srvGas.ListAll(cond)
 	for _, scheme := range lists {
 		if len(scheme.AreaIds) <= 0 {
 			continue
 		}
-		var areaIds []uint
-		for _, val := range strings.Split(scheme.AreaIds, ",") {
-			tmpId, err := strconv.ParseUint(val, 10, 64)
-			if err != nil {
-				continue
+		needBill := "1"
+		if len(scheme.MigrDate) > 0 {
+			date, err := strconv.Atoi(scheme.MigrDate)
+			if err != nil && date < time.Now().Day() {
+				needBill = "0"
 			}
-			areaIds = append(areaIds, uint(tmpId))
 		}
-		deviceIds, _ := task.srvCommon.ListAreaDeviceIds(areaIds, []string{"gas"})
-
-		deviceList, _ := task.srvApportionDevice.ListAllBindDevice(scheme.Id, "gas", nil, deviceIds)
-		billingMethod := scheme.BillingMethod
-		var schemeTimes []*SchemeTime
-		switch billingMethod {
-		case "1", "2":
-			schemeTimes = getDateStd(0, billingMethod, startDay, endDay, scheme.Price)
-			break
-		case "3":
-			schemeTimes = getYearDateStd(0, billingMethod, startDay, endDay, scheme.Price)
-			break
-		}
-		if schemeTimes == nil {
+		deviceRecords, err := task.srvRecord.ListByHouseId(0, 0, deviceId, "", true, startDay, endDay)
+		if err == nil {
 			continue
 		}
-
-		usageTotal := float64(0.00)
 		billAmount := float64(0.00)
-		var deviceRecords []finModel.FinDeviceRecord
-		for i := 0; i < len(deviceList); i++ {
-			device := deviceList[i]
-			num, err := task.srvRecord.GetRecordNum(device.HouseId, device.DeviceId, constants.BillTypeEnum.SElectric, startDay, endDay)
+
+		var saveRecords []finModel.FinDeviceRecord
+		for _, record := range deviceRecords {
+			num, err := task.srvRecord.GetRecordNum(0, record.DeviceId, constants.BillTypeEnum.SElectric, startDay, endDay)
 			if err != nil || num > 0 {
 				continue
 			}
-			totalUsageStart := 0.00
-			totalUsageEnd := 0.00
-			for _, schemeTime := range schemeTimes {
-				startValue, err := task.srvInstrument.QueryDeviceFirstValue(device.DeviceId, schemeTime.startDay.Unix())
-				if err != nil {
-					startValue = 0.00
-				}
-				endValue, err := task.srvInstrument.QueryDeviceFirstValue(device.DeviceId, schemeTime.endDay.Unix())
-				if err != nil {
-					endValue, _, _ = task.srvInstrument.QueryNewDeviceValue(device.DeviceId, schemeTime.startDay.Unix(), schemeTime.endDay.Unix())
-				}
-				if endValue == 0.00 {
-					endValue = startValue
-				}
-				totalUsageStart += startValue
-				totalUsageEnd += endValue
-				usageTotal += endValue - startValue
-				schemeTime.usageTotal = endValue - startValue
-				schemeTime.regionId = device.RegionId
-				schemeTime.regionName = device.RegionName
-				schemeTime.areaId = device.AreaId
-				schemeTime.areaName = device.AreaName
-				schemeTime.houseId = device.HouseId
-				schemeTime.houseName = device.HouseName
-			}
-			switch billingMethod {
-			case "1":
-				schemeTimes = calcUnitFee(schemeTimes)
-				break
-			case "2":
-				schemeTimes = calcMonthFee(schemeTimes)
-				break
-			case "3":
-				schemeTimes = calcYearFee(schemeTimes)
-				break
-			default:
-				break
-			}
-			for _, schemeTime := range schemeTimes {
-				billAmount += schemeTime.billAmmount
-			}
-			record := finModel.FinDeviceRecord{
-				SchemeId:   scheme.Id,
-				BillType:   constants.BillTypeEnum.SElectric,
-				RegionId:   scheme.RegionId,
-				RegionName: scheme.RegionName,
-				AreaId:     scheme.AreaId,
-				AreaName:   scheme.AreaName,
-				HouseId:    device.HouseId,
-				HouseName:  device.HouseName,
-				DeviceId:   device.DeviceId,
-				DeviceName: device.DeviceName,
-				FeeDate:    startDay,
-				BillAmount: billAmount,
-				UsageTotal: usageTotal,
-				UsageStart: totalUsageStart,
-				UsageEnd:   totalUsageEnd,
-			}
+			var item finModel.FinDeviceRecord
+			response.Copy(record, &item)
+			item.Id = 0
+			item.SchemeId = scheme.Id
+			item.BillType = constants.BillTypeEnum.SElectric
+			item.CommonAreaId = record.HouseId
+			item.CommonAreaName = record.HouseName
+			item.FeeDate = startDay
+			item.StepFee = record.StepFee
+			item.NeedBill = needBill
 			record.CreateTime = now
-			deviceRecords = append(deviceRecords, record)
+			saveRecords = append(saveRecords, item)
 		}
 		switch scheme.ApportionMethod {
 		case "0":
-			deviceRecords = task.srvSharedCommon.calcSharedSquareFee(deviceRecords, scheme.SquareType, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedSquareFee(saveRecords, deviceTypes, scheme.MigrDate, startDay, scheme.SquareType, billAmount)
 			break
 		case "1":
-			deviceRecords = task.srvSharedCommon.calcSharedHouseFee(deviceRecords, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedHouseFee(saveRecords, deviceTypes, scheme.MigrDate, startDay, billAmount)
 			break
 		case "2":
-			deviceRecords = task.srvSharedCommon.calcSharedSelfFee(deviceRecords, scheme.Price, startDay, endDay, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedSelfFee(saveRecords, deviceTypes, scheme.MigrDate, scheme.Price, startDay, endDay, billAmount)
 			break
 		}
-		if len(deviceRecords) > 0 {
-			task.srvRecord.SaveBatch(deviceRecords)
+		if len(saveRecords) > 0 {
+
+			purseRecordMap := make(map[uint]finReq.FinPurseFeeEditReq)
+			if len(saveRecords) > 0 {
+				err := task.srvRecord.SaveBatch(saveRecords)
+				if err != nil {
+					continue
+				}
+				for _, record := range saveRecords {
+					feeReq, find := purseRecordMap[record.HouseId]
+					if !find {
+						purse, err := task.srvPurse.DetailByHouseId(record.HouseId, nil)
+						if err != nil && purse.Id <= 0 {
+							continue
+						}
+						feeReq = finReq.FinPurseFeeEditReq{
+							HouseId:       record.HouseId,
+							EcsType:       "gas",
+							FeeType:       "deduct",
+							FlowType:      "purse",
+							Amount:        record.BillAmount,
+							PaymentTime:   now,
+							PaymentSource: "0",
+							PaymentMethod: "0",
+						}
+					}
+					feeReq.Amount += record.BillAmount
+					purseRecordMap[record.HouseId] = feeReq
+				}
+				for _, purseReq := range purseRecordMap {
+					jsStr, err := json.Marshal(purseReq)
+					if err != nil {
+						continue
+					}
+					util.RedisUtil.LPush(constants.Task_Purse_Que, jsStr)
+				}
+			}
 		}
 	}
 }
diff --git a/app/fin/task/billing_shared_water_task.go b/app/fin/task/billing_shared_water_task.go
index 4a7a9bccdb2734c0ee0b7457ed0154ee900bb0d6..0b4297a21b2e58c89c1357ae888ff2855806260e 100644
--- a/app/fin/task/billing_shared_water_task.go
+++ b/app/fin/task/billing_shared_water_task.go
@@ -1,14 +1,16 @@
 package task
 
 import (
+	"encoding/json"
 	"strconv"
-	"strings"
 	"time"
 
 	"energy-server-mgo/app/fin/constants"
 	finReq "energy-server-mgo/app/fin/schemas"
 	finSvr "energy-server-mgo/app/fin/service"
 	"energy-server-mgo/core"
+	"energy-server-mgo/core/response"
+	"energy-server-mgo/util"
 
 	devSvr "energy-server-mgo/app/admin/service/device"
 	finModel "energy-server-mgo/app/fin/model"
@@ -28,6 +30,7 @@ type SharedWaterTask struct {
 	srvRecord          finSvr.IFinDeviceRecordService
 	srvApportionRatio  finSvr.IFinApportionRatioService
 	srvScheme          finSvr.IFinApportionSchemesService
+	srvPurse           finSvr.IFinPurseService
 }
 
 // NewSharedWaterTask 实例化
@@ -78,141 +81,105 @@ func newSharedWaterTask() *SharedWaterTask {
 	}); err != nil {
 		panic(err)
 	}
+	if err := core.GetContainer().Invoke(func(s finSvr.IFinPurseService) {
+		server.srvPurse = s
+	}); err != nil {
+		panic(err)
+	}
 	server.srvSharedCommon = NewSharedCommon()
 
 	return server
 }
 
 // 计算水务公摊费用
-func (task *SharedWaterTask) calcFee() {
-	core.TryLock(constants.Lock_key_SWater, "1", 5*time.Minute)
-	defer core.UnLock(constants.Lock_key_SWater)
-
+func (task *SharedWaterTask) calcFee(houseId uint, deviceId uint, startDay, endDay time.Time) {
 	now := time.Now()
-	// 将时间截断到当天的零点
-	endDay := time.Date(now.Year(), now.Month(), now.Day(), 0, 0, 0, 0, now.Location())
-	startDay := endDay.AddDate(0, 0, -1)
+	deviceTypes := []string{"cool", "hw"}
 
 	var cond finReq.FinSharedListReq
+	cond.CommonAreaId = houseId
 	lists, _ := task.srvWater.ListAll(cond)
 	for _, scheme := range lists {
-		if len(scheme.AreaIds) <= 0 {
-			continue
-		}
-		var areaIds []uint
-		for _, val := range strings.Split(scheme.AreaIds, ",") {
-			tmpId, err := strconv.ParseUint(val, 10, 64)
-			if err != nil {
-				continue
+		needBill := "1"
+		if len(scheme.MigrDate) > 0 {
+			date, err := strconv.Atoi(scheme.MigrDate)
+			if err != nil && date < time.Now().Day() {
+				needBill = "0"
 			}
-			areaIds = append(areaIds, uint(tmpId))
 		}
-		deviceIds, _ := task.srvCommon.ListAreaDeviceIds(areaIds, []string{"hw", "cool"})
-
-		deviceList, _ := task.srvApportionDevice.ListAllBindDevice(scheme.Id, "water", nil, deviceIds)
-		billingMethod := scheme.BillingMethod
-		var schemeTimes []*SchemeTime
-		switch billingMethod {
-		case "1", "2":
-			schemeTimes = getDateStd(0, billingMethod, startDay, endDay, scheme.Price)
-			break
-		case "3":
-			schemeTimes = getYearDateStd(0, billingMethod, startDay, endDay, scheme.Price)
-			break
-		case "4", "5":
-			schemeTimes = getStepDateStd(0, billingMethod, startDay, endDay, scheme.Price)
-			break
-		}
-		if schemeTimes == nil {
+		deviceRecords, err := task.srvRecord.ListByHouseId(0, 0, deviceId, "", true, startDay, endDay)
+		if err == nil {
 			continue
 		}
-
-		usageTotal := float64(0.00)
 		billAmount := float64(0.00)
-		var deviceRecords []finModel.FinDeviceRecord
-		for i := 0; i < len(deviceList); i++ {
-			device := deviceList[i]
-			num, err := task.srvRecord.GetRecordNum(device.HouseId, device.DeviceId, constants.BillTypeEnum.SElectric, startDay, endDay)
+
+		var saveRecords []finModel.FinDeviceRecord
+		for _, record := range deviceRecords {
+			num, err := task.srvRecord.GetRecordNum(0, record.DeviceId, constants.BillTypeEnum.SElectric, startDay, endDay)
 			if err != nil || num > 0 {
 				continue
 			}
-			totalUsageStart := 0.00
-			totalUsageEnd := 0.00
-			for _, schemeTime := range schemeTimes {
-				startValue, err := task.srvInstrument.QueryDeviceFirstValue(device.DeviceId, schemeTime.startDay.Unix())
-				if err != nil {
-					startValue = 0.00
-				}
-				endValue, err := task.srvInstrument.QueryDeviceFirstValue(device.DeviceId, schemeTime.endDay.Unix())
-				if err != nil {
-					endValue, _, _ = task.srvInstrument.QueryNewDeviceValue(device.DeviceId, schemeTime.startDay.Unix(), schemeTime.endDay.Unix())
-				}
-				if endValue == 0.00 {
-					endValue = startValue
-				}
-				totalUsageStart += startValue
-				totalUsageEnd += endValue
-				usageTotal += endValue - startValue
-				schemeTime.usageTotal = endValue - startValue
-				schemeTime.regionId = device.RegionId
-				schemeTime.regionName = device.RegionName
-				schemeTime.areaId = device.AreaId
-				schemeTime.areaName = device.AreaName
-				schemeTime.houseId = device.HouseId
-				schemeTime.houseName = device.HouseName
-			}
-			switch billingMethod {
-			case "1":
-				schemeTimes = calcUnitFee(schemeTimes)
-				break
-			case "2":
-				schemeTimes = calcMonthFee(schemeTimes)
-				break
-			case "3":
-				schemeTimes = calcYearFee(schemeTimes)
-				break
-			case "4", "5":
-				schemeTimes = calcStepFee(schemeTimes)
-				break
-			default:
-				break
-			}
-			for _, schemeTime := range schemeTimes {
-				billAmount += schemeTime.billAmmount
-			}
-			record := finModel.FinDeviceRecord{
-				SchemeId:   scheme.Id,
-				BillType:   constants.BillTypeEnum.SElectric,
-				RegionId:   scheme.RegionId,
-				RegionName: scheme.RegionName,
-				AreaId:     scheme.AreaId,
-				AreaName:   scheme.AreaName,
-				HouseId:    device.HouseId,
-				HouseName:  device.HouseName,
-				DeviceId:   device.DeviceId,
-				DeviceName: device.DeviceName,
-				FeeDate:    startDay,
-				BillAmount: billAmount,
-				UsageTotal: usageTotal,
-				UsageStart: totalUsageStart,
-				UsageEnd:   totalUsageEnd,
-			}
+			var item finModel.FinDeviceRecord
+			response.Copy(record, &item)
+			item.Id = 0
+			item.SchemeId = scheme.Id
+			item.BillType = constants.BillTypeEnum.SElectric
+			item.CommonAreaId = record.HouseId
+			item.CommonAreaName = record.HouseName
+			item.FeeDate = startDay
+			item.StepFee = record.StepFee
+			item.NeedBill = needBill
 			record.CreateTime = now
-			deviceRecords = append(deviceRecords, record)
+			saveRecords = append(saveRecords, item)
 		}
 		switch scheme.ApportionMethod {
 		case "0":
-			deviceRecords = task.srvSharedCommon.calcSharedSquareFee(deviceRecords, scheme.SquareType, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedSquareFee(saveRecords, deviceTypes, scheme.MigrDate, startDay, scheme.SquareType, billAmount)
 			break
 		case "1":
-			deviceRecords = task.srvSharedCommon.calcSharedHouseFee(deviceRecords, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedHouseFee(saveRecords, deviceTypes, scheme.MigrDate, startDay, billAmount)
 			break
 		case "2":
-			deviceRecords = task.srvSharedCommon.calcSharedSelfFee(deviceRecords, scheme.Price, startDay, endDay, billAmount)
+			deviceRecords = task.srvSharedCommon.calcSharedSelfFee(saveRecords, deviceTypes, scheme.MigrDate, scheme.Price, startDay, endDay, billAmount)
 			break
 		}
-		if len(deviceRecords) > 0 {
-			task.srvRecord.SaveBatch(deviceRecords)
+		if len(saveRecords) > 0 {
+
+			purseRecordMap := make(map[uint]finReq.FinPurseFeeEditReq)
+			if len(saveRecords) > 0 {
+				err := task.srvRecord.SaveBatch(saveRecords)
+				if err != nil {
+					continue
+				}
+				for _, record := range saveRecords {
+					feeReq, find := purseRecordMap[record.HouseId]
+					if !find {
+						purse, err := task.srvPurse.DetailByHouseId(record.HouseId, nil)
+						if err != nil && purse.Id <= 0 {
+							continue
+						}
+						feeReq = finReq.FinPurseFeeEditReq{
+							HouseId:       record.HouseId,
+							EcsType:       "water",
+							FeeType:       "deduct",
+							FlowType:      "purse",
+							Amount:        record.BillAmount,
+							PaymentTime:   now,
+							PaymentSource: "0",
+							PaymentMethod: "0",
+						}
+					}
+					feeReq.Amount += record.BillAmount
+					purseRecordMap[record.HouseId] = feeReq
+				}
+				for _, purseReq := range purseRecordMap {
+					jsStr, err := json.Marshal(purseReq)
+					if err != nil {
+						continue
+					}
+					util.RedisUtil.LPush(constants.Task_Purse_Que, jsStr)
+				}
+			}
 		}
 	}
 }
diff --git a/app/fin/task/general.go b/app/fin/task/general.go
index 781b4f283bd5247b8746d707a88ea926661c60ca..33f58cff1873afa0acff2a883ae7edf9c3b0a947 100644
--- a/app/fin/task/general.go
+++ b/app/fin/task/general.go
@@ -229,6 +229,7 @@ func getStepDateStd(paymentDay int, billingMethod string, startDay time.Time, en
 		for i := 0; i < int(dayNum); i++ {
 			tmpStartDay := startDay.AddDate(0, 0, i)
 			var schemeTime SchemeTime
+			schemeTime.seq, _ = strconv.Atoi(price.Seq)
 			schemeTime.startDay = time.Date(tmpStartDay.Year(), tmpStartDay.Month(), tmpStartDay.Day(), startHour, startMinute, 0, 0, now.Location())
 			schemeTime.endDay = time.Date(tmpStartDay.Year(), tmpStartDay.Month(), tmpStartDay.Day(), endHour, endMinute, 0, 0, now.Location())
 			schemeTime.prices = make([]interface{}, 1)
